import type { Settings as LayoutSettings } from '@ant-design/pro-layout';
import { PageLoading } from '@ant-design/pro-layout';
import type { RunTimeLayoutConfig } from 'umi';
import { history, Link } from 'umi';
import RightContent from '@/components/RightContent';
import Footer from '@/components/Footer';
import { currentUser as queryCurrentUser, queryPersonTxByYw } from './services/ant-design-pro/api';
import { BookOutlined, LinkOutlined } from '@ant-design/icons';
import { RequestConfig } from 'umi';
import { ResponseError } from 'umi-request';
import { message, notification } from 'antd';
import cookie from 'react-cookies';

const isDev = process.env.NODE_ENV === 'development';
const loginPath = '/user/login';

/** 获取用户信息比较慢的时候会展示一个 loading */
export const initialStateConfig = {
  loading: <PageLoading />,
};

/**
 * @see  https://umijs.org/zh-CN/plugins/plugin-initial-state
 * */
export async function getInitialState(): Promise<{
  settings?: Partial<LayoutSettings>;
  currentUser?: API.CurrentUser;
  fetchUserInfo?: () => Promise<API.CurrentUser | undefined>;
}> {
  const fetchUserInfo = async () => {
    try {
      const msg = await queryCurrentUser({
        person_id: cookie.load('person_id'),
        identity_id: cookie.load('identity_id'),
        u_type: 1, // 用户类型
        random_num: new Date().getTime(),
      });
      const tx = await queryPersonTxByYw({
        person_id: cookie.load('person_id'),
        identity_id: cookie.load('identity_id'),
        u_type: 1, // 用户类型
        random_num: new Date().getTime(),
      });
      console.log('avatar: ',`/dsideal_yy/html/thumb/Material/${tx?.file_id?.substr(0,2)}/${tx?.file_id}.${tx?.extension}`)
      return {name: msg?.person_name, userid: msg?.person_id, avatar: `/dsideal_yy/html/thumb/Material/${tx?.file_id?.substr(0,2)}/${tx?.file_id}.${tx?.extension}`};
    } catch (error) {
      history.push(loginPath);
    }
    return undefined;
  };
  // 如果是登录页面，不执行
  if (history.location.pathname !== loginPath) {
    const currentUser = await fetchUserInfo();
    return {
      fetchUserInfo,
      currentUser,
      settings: {},
    };
  }
  return {
    fetchUserInfo,
    settings: {},
  };
}

// ProLayout 支持的api https://procomponents.ant.design/components/layout
export const layout: RunTimeLayoutConfig = ({ initialState }) => {
  return {
    rightContentRender: () => <RightContent />,
    disableContentMargin: false,
    /*
    waterMarkProps: {
      content: initialState?.currentUser?.name,
    },*/
    footerRender: () => <Footer />,
    onPageChange: () => {
      const { location } = history;
      // 如果没有登录，重定向到 login
      if (!initialState?.currentUser && location.pathname !== loginPath) {
        history.push(loginPath);
      }
    },
    menuHeaderRender: undefined,
    // 自定义 403 页面
    // unAccessible: <div>unAccessible</div>,
    ...initialState?.settings,
  };
};

/** 全局响应拦截 */
const responseInterceptor = async (response: any, options: any) => {
  const data = await response.clone().json();
  if (data && data?.status === '0') {
    //location.href = location.pathname + '#/user/login'; // /#/user/login
    history.push('/user/login')
  }
  // console.log('返回了', response);
  // console.log('options', options);
  // console.log('data', data)
  if(data?.success === false && options?.url === '/dsideal_yy/checkLoginStatus'){
    message.error(data?.info)
  }
  return response;
};

/** request 用于配置全局的网络请求，你可以在这里做拦截器，全局错误处理，鉴权的配置。*/
export const request: RequestConfig = {
  errorHandler: (error: ResponseError) => {
    console.log('RequestConfig errorHandler', error)
    /*
    notification.error({
      description: '您的网络发生异常，无法连接服务器',
      message: '网络异常',
    });*/
    throw error;
  },
  //middlewares?: OnionMiddleware[],
  //requestInterceptors: [requestInterceptor], // 请求前拦截器
  responseInterceptors: [responseInterceptor], // 响应拦截器
};
